#ifndef HAVE_PLATFORM_H
#define HAVE_PLATFORM_H

#include <xs1.h>

/*
 * Platform description header file.
 * Automatically generated from "..\.\src\core\xr-usb-audio-2.0.xn".
 */

#ifdef __XC__
/* Core array declaration. */
extern core stdcore[1];
#endif

#ifdef __XC__
/* Service prototypes. */
/* none */
#endif

#if defined(__XC__)
#define PORT_SPI_MISO on stdcore[0]: XS1_PORT_1A
#define PORT_SPI_SS on stdcore[0]: XS1_PORT_1B
#define PORT_SPI_CLK on stdcore[0]: XS1_PORT_1C
#define PORT_SPI_MOSI on stdcore[0]: XS1_PORT_1D
#define PORT_I2S_BCLK on stdcore[0]: XS1_PORT_1A
#define PORT_I2S_LRCLK on stdcore[0]: XS1_PORT_1C
#define PORT_I2S_DAC0 on stdcore[0]: XS1_PORT_1D
#define PORT_I2S_ADC0 on stdcore[0]: XS1_PORT_1I
#define PORT_MIDI_OUT on stdcore[0]: XS1_PORT_1J
#define PORT_MIDI_IN on stdcore[0]: XS1_PORT_1K
#define PORT_SPDIF_OUT on stdcore[0]: XS1_PORT_1L
#define PORT_MCLK_IN on stdcore[0]: XS1_PORT_1M
#define PORT_MCLK_COUNT on stdcore[0]: XS1_PORT_16B
#define PORT_USB_RESET on stdcore[0]: XS1_PORT_32A
#else
#define PORT_SPI_MISO XS1_PORT_1A
#define PORT_SPI_SS XS1_PORT_1B
#define PORT_SPI_CLK XS1_PORT_1C
#define PORT_SPI_MOSI XS1_PORT_1D
#define PORT_I2S_BCLK XS1_PORT_1A
#define PORT_I2S_LRCLK XS1_PORT_1C
#define PORT_I2S_DAC0 XS1_PORT_1D
#define PORT_I2S_ADC0 XS1_PORT_1I
#define PORT_MIDI_OUT XS1_PORT_1J
#define PORT_MIDI_IN XS1_PORT_1K
#define PORT_SPDIF_OUT XS1_PORT_1L
#define PORT_MCLK_IN XS1_PORT_1M
#define PORT_MCLK_COUNT XS1_PORT_16B
#define PORT_USB_RESET XS1_PORT_32A
#endif


/* Reference frequency definition. */
#define PLATFORM_REFERENCE_HZ 100000000
#define PLATFORM_REFERENCE_KHZ 100000
#define PLATFORM_REFERENCE_MHZ 100

#endif /* HAVE_PLATFORM_H */

