#ifndef GLOBAL_H_
#define GLOBAL_H_

// Global settings and configuration variables

// ---- Board type ----
#ifdef BOARD_2V0_DEV
#warning "WARNING: You are using 2v0 dev board...."
#include "ipod_dock_2v0_dev.h"
#endif

#ifdef BOARD_2V0
#include "ipod_dock_2v0.h"
#endif

#define ENFORCE_FAST_MODE

// ---- Release mode: ----
// Debug statements removed, streaming channels used, etc.
// Defined when calling makefile with RELEASE=1

// ---- Audio Output mode: ----
// OUTPUT is now defined via makefile option (default is i2s)
// Options are:
// OUTPUT=I2S, OUTPUT=SPDIF, OUTPUT=I2SSPDIF, OUTPUT=CLASSD

// Number of USB clients for the USB stack
#define NUM_CTRL_CHANENDS 3

// ----------------------------------------------------------------------


#ifdef RELEASE
#define USE_STREAMING_CHANNELS
#undef VERBOSE
#else
#undef USE_STREAMING_CHANNELS
#define VERBOSE
#endif

#include <xs1.h>

// ------------------------------------------------------------------------------------------------------------
#include "print.h"
#ifdef VERBOSE
#define vprintstr(a)   printstr(a)
#define vprinthexln(a) printhexln(a)
#define vprintstrln(a) printstrln(a)
#define vprintintln(a) printintln(a)
#else
#define vprintstr(a)
#define vprinthexln(a)
#define vprintstrln(a)
#define vprintintln(a)
#endif

#define vprint(a) { vprintstrln(a); return 1;}
#define vprinti(a) { vprintintln(a); return 1; }

#ifdef __XC__
#ifdef USE_STREAMING_CHANNELS
#define streaming_chanend streaming chanend
#else
#define streaming_chanend chanend
#endif
#else
#define streaming_chanend unsigned
#endif

#endif /*GLOBAL_H_*/
