/*
 * spi.c
 *
 * Created: 20. 1. 2014 12:18:28
 *  Author: Jaroslav Dohnal, Bluestring
 *
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
 * EXPRESSLY AND SPECIFICALLY DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include "spi.h"

volatile uint8_t data;

ISR (SPI_STC_vect) //SPI interrupt vector handler
{	
	data = SPDR;
	if (data != 0xFF)
		board_setSampleFreq(data);
}

void SPI_init(void){
	
	//set MISO as output, all others input
	DDRB |= (1<<PB4);
	
	//enable SPI, slave
	SPCR |= (1<<CPOL)|(1<<CPHA)|(1<<SPIE);
	SPCR |= (1<<SPE); 

	//enable global interrupt
	sei();
	
	while(TRUE){
		set_sleep_mode(SLEEP_MODE_IDLE);
		sleep_enable();
		sleep_mode();
		/* sleeping */
		sleep_disable(); //jump here after wake up
	}
}