/*
 * gpio.c
 *
 * Created: 5. 11. 2013 21:26:47
 *  Author: Jaroslav Dohnal
 */ 

#include "gpio.h"

void gpio_write(uint8_t pin){
	DDRB |= (1<<pin);
	PORTB |= (1<<pin);
}

void gpio_clear(uint8_t pin){
	DDRB |= (1<<pin);
	PORTB &= ~(1<<pin);
}

uint8_t gpio_read(uint8_t pin){
	DDRB &= ~(1<<pin);
	return PINB & (1<<pin);
}

uint8_t gpio_read_pullup(uint8_t pin){
	DDRB &= ~(1<<pin);
	PORTB |= (1<<pin);
	return (PINB & (1<<pin));
}