/*
 * relay_board.c
 *
 * Created: 5. 11. 2013 21:22:18
 *  Author: Jaroslav Dohnal
 */ 

#define F_CPU 1000000UL

#include "gpio.h"
#include <util/delay.h>

#define OFF 0
#define GREEN 1
#define RED 2

#define FALSE 0
#define TRUE 1

void ledState(uint8_t state);
uint8_t readButton(void);
void relayOn(uint8_t state);

int main(void)
{
	uint8_t previousStateOn = TRUE;
	
	ledState(RED);
	
    while(1)
    {
        if (readButton())
        {
			while(readButton());
			_delay_ms(20);
			
			if (previousStateOn == FALSE)
			{
				relayOn(TRUE);
				ledState(GREEN);
				_delay_ms(300);
				previousStateOn = TRUE;
			}
			else if (previousStateOn == TRUE)
			{
				relayOn(FALSE);
				ledState(RED);
				_delay_ms(300);
				previousStateOn = FALSE;
			}	
		}
    }
}

void ledState(uint8_t state){
	if (state == GREEN)
	{
		gpio_write(PB3);
		gpio_clear(PB2);
	}
	else if (state == RED)
	{
		gpio_clear(PB3);
		gpio_write(PB2);
	}
	else if (state == OFF)
	{
		gpio_clear(PB2);
		gpio_clear(PB3);
	}
}

uint8_t readButton(void){
	return !(gpio_read_pullup(PB4));
}

void relayOn(uint8_t state){
	if(state == TRUE)
	{
		gpio_write(PB0);	
	}
	else if (state == FALSE)
	{
		gpio_clear(PB0);
	}
}